/* eslint-disable @next/next/no-img-element */
import CardList from "@/components/High/CardList";
import Layout from "@/components/High/Layout";
import Tooltip from "@/components/Low/Tooltip";
import {useListSearch} from "@/hooks/useListSearch";
import usePagination from "@/hooks/usePagination";
import {Entity, EntityWithRoles, Role} from "@/interfaces/entity";
import {GroupWithUsers, User} from "@/interfaces/user";
import {sessionOptions} from "@/lib/session";
import {USER_TYPE_LABELS} from "@/resources/user";
import {getEntityWithRoles} from "@/utils/entities.be";
import {convertToUsers, getGroup} from "@/utils/groups.be";
import {shouldRedirectHome} from "@/utils/navigation.disabled";
import {checkAccess, getTypesOfUser} from "@/utils/permissions";
import {getUserName} from "@/utils/users";
import {getEntityUsers, getLinkedUsers, getSpecificUsers} from "@/utils/users.be";
import axios from "axios";
import clsx from "clsx";
import {withIronSessionSsr} from "iron-session/next";
import moment from "moment";
import Head from "next/head";
import Link from "next/link";
import {useRouter} from "next/router";
import {Divider} from "primereact/divider";
import {useEffect, useMemo, useState} from "react";
import {
	BsChevronLeft,
	BsClockFill,
	BsEnvelopeFill,
	BsFillPersonVcardFill,
	BsPlus,
	BsSquare,
	BsStopwatchFill,
	BsTag,
	BsTrash,
	BsX,
} from "react-icons/bs";
import {toast, ToastContainer} from "react-toastify";

export const getServerSideProps = withIronSessionSsr(async ({req, params}) => {
	const user = req.session.user as User;

	if (!user) {
		return {
			redirect: {
				destination: "/login",
				permanent: false,
			},
		};
	}

	if (shouldRedirectHome(user)) {
		return {
			redirect: {
				destination: "/",
				permanent: false,
			},
		};
	}

	const {id} = params as {id: string};

	const entityWithRoles = await getEntityWithRoles(id);
	if (!entityWithRoles || (checkAccess(user, getTypesOfUser(["admin", "developer"])) && !user.entities.map((x) => x.id).includes(id))) {
		return {
			redirect: {
				destination: "/entities",
				permanent: false,
			},
		};
	}

	const {entity, roles} = entityWithRoles;

	const linkedUsers = await getLinkedUsers(user.id, user.type);
	const users = await getEntityUsers(id);

	return {
		props: {
			user,
			entity: JSON.parse(JSON.stringify(entity)),
			roles: JSON.parse(JSON.stringify(roles)),
			users: JSON.parse(JSON.stringify(users)),
			linkedUsers: JSON.parse(JSON.stringify(linkedUsers.users)),
		},
	};
}, sessionOptions);

interface Props {
	user: User;
	entity: Entity;
	roles: Role[];
	users: User[];
	linkedUsers: User[];
}

export default function Home({user, entity, roles, users, linkedUsers}: Props) {
	const [isEditing, setIsEditing] = useState(false);
	const [isLoading, setIsLoading] = useState(false);

	const router = useRouter();

	const allowEntityEdit = useMemo(() => checkAccess(user, ["admin", "developer"]), [user]);

	const renameGroup = () => {
		if (!allowEntityEdit) return;

		const name = prompt("Rename this entity:", entity.label);
		if (!name) return;

		setIsLoading(true);
		axios
			.patch(`/api/entities/${entity.id}`, {name})
			.then(() => {
				toast.success("The entity has been updated successfully!");
				router.replace(router.asPath);
			})
			.catch((e) => {
				console.error(e);
				toast.error("Something went wrong!");
			})
			.finally(() => setIsLoading(false));
	};

	const deleteGroup = () => {
		if (!allowEntityEdit) return;
		if (!confirm("Are you sure you want to delete this entity?")) return;

		setIsLoading(true);

		axios
			.delete(`/api/entities/${entity.id}`)
			.then(() => {
				toast.success("This entity has been successfully deleted!");
				router.replace("/entities");
			})
			.catch((e) => {
				console.error(e);
				toast.error("Something went wrong!");
			})
			.finally(() => setIsLoading(false));
	};

	const firstCard = () => (
		<Link
			href={`/entities/${entity.id}/role`}
			className="p-4 border hover:text-mti-purple rounded-xl flex flex-col items-center justify-center gap-0 hover:border-mti-purple transition ease-in-out duration-300 text-left cursor-pointer">
			<BsPlus size={40} />
			<span className="font-semibold">Create Role</span>
		</Link>
	);

	const renderCard = (role: Role) => {
		const usersWithRole = users.filter((x) => x.entities.map((x) => x.role).includes(role.id));

		return (
			<button
				disabled={!allowEntityEdit}
				key={role.id}
				className={clsx(
					"p-4 pr-6 h-48 relative border rounded-xl flex flex-col gap-3  text-left cursor-pointer",
					"hover:border-mti-purple transition ease-in-out duration-300",
				)}>
				<div className="flex flex-col">
					<span className="font-semibold">{role.label}</span>
					<span className="opacity-80 text-sm">{usersWithRole.length} members</span>
				</div>

				<b>Permissions ({role.permissions.length}): </b>
				<span>
					{role.permissions.slice(0, 5).join(", ")}
					{role.permissions.length > 5 ? <span className="opacity-60"> and {role.permissions.length - 5} more</span> : ""}
				</span>
			</button>
		);
	};

	return (
		<>
			<Head>
				<title>{entity.label} | EnCoach</title>
				<meta
					name="description"
					content="A training platform for the IELTS exam provided by the Muscat Training Institute and developed by eCrop."
				/>
				<meta name="viewport" content="width=device-width, initial-scale=1" />
				<link rel="icon" href="/favicon.ico" />
			</Head>
			<ToastContainer />
			{user && (
				<Layout user={user}>
					<section className="flex flex-col gap-0">
						<div className="flex flex-col gap-3">
							<div className="flex items-end justify-between">
								<div className="flex items-center gap-2">
									<Link
										href={`/entities/${entity.id}`}
										className="text-mti-purple hover:text-mti-purple-dark transition ease-in-out duration-300 text-xl">
										<BsChevronLeft />
									</Link>
									<h2 className="font-bold text-2xl">{entity.label}</h2>
								</div>
							</div>
							{allowEntityEdit && !isEditing && (
								<div className="flex items-center gap-2">
									<button
										onClick={renameGroup}
										disabled={isLoading}
										className="flex items-center gap-1 px-2 py-2 border rounded-full hover:bg-neutral-100 disabled:hover:bg-transparent disabled:opacity-50 disabled:cursor-not-allowed cursor-pointer transition ease-in-out duration-300">
										<BsTag />
										<span className="text-xs">Rename Entity</span>
									</button>
									<button
										onClick={deleteGroup}
										disabled={isLoading}
										className="flex items-center gap-1 px-2 py-2 border border-mti-rose rounded-full bg-mti-rose-light text-white hover:bg-mti-rose-dark disabled:hover:bg-mti-rose-light disabled:opacity-50 disabled:cursor-not-allowed cursor-pointer transition ease-in-out duration-300">
										<BsTrash />
										<span className="text-xs">Delete Entity</span>
									</button>
								</div>
							)}
						</div>
						<Divider />
						<span className="font-semibold text-xl mb-4">Roles</span>

						<CardList list={roles} searchFields={[["label"]]} renderCard={renderCard} firstCard={firstCard} />
					</section>
				</Layout>
			)}
		</>
	);
}
